program Graph_29b;
{
     ,  
}
{$APPTYPE CONSOLE}

uses
  SysUtils, DateUtils,
  Assembly in '..\Common\Assembly.pas',
  Graph in '..\Common\Graph.pas',
  GrChars in '..\Common\GrChars.pas',
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas',
  SetList in '..\Common\SetList.pas',
  SetUtils in '..\Common\SetUtils.pas';

var Gr : TGraph;
    Res : TCostSet;   // 
    Nodes : integer;  //  

    Start: TDateTime;
    Time : integer;

//////////////////////////////////////////////////////////////
//     

procedure ResultExpo(const aFile: String);
var Pair : TItem;
begin
  if aFile <> '' then begin
    Assign(Output, aFile);
    if FileExists(aFile)  then Append(Output) else Rewrite(Output)
  end;
  Writeln('-------------------------------------');
  with Res do begin
    if mCost<0 then Exit;
    Pair:= mSet.GetFirst;
    while Assigned(Pair) do begin
      if Pair is TLink then
        with Pair as TLink do Writeln(mOwner.GetName + '-'
                                    + mDest.GetName, ' =', mValue:3)
        else begin Pair.Expo; Writeln end;
      Pair:= mSet.GetNext;
    end;
    Writeln('Nodes= ', Gr.Nodes);
    Writeln('Cost = ', mCost);
  end;
  Writeln('Time = ', Time,' ms');
  if aFile <> '' then begin
    Close(Output);  Assign(Output, '');    Rewrite(Output);
  end;
end;

//////////////////////////////////////////////////////////////
const CFile = 'Out.txt';

begin
  try
    repeat
      Write('Nodes= '); Readln(Nodes);
      if Nodes < 3 then Break;
      //    
      Gr:= THugeGraph.GenDicoty(99, Nodes);
      {
          
      Gr:= TGraphChars.Load('Dicoty-8.txt');
      }
//    if Nodes < 9 then Gr.Expo;
//    if Nodes <=7  then begin
        Start:= Now;
        Res:= Gr.GenPairs(pMinW, 0);
        //Res:= Gr.GenPairs(pMaxN, 0);
        Time:= MilliSecondsBetween(Start, Now);
        ResultExpo('');
        ResultExpo(CFile);
        Res.mSet.ClrAndDestroy;
        Res.Free;
//    end;
      (*
      Start:= Now;
      Res:= Gr.GenMinPairsDicotyFlow;
      Time:= MilliSecondsBetween(Start, Now);
      ResultExpo('');
      ResultExpo(CFile);
      Res.Free;
      *)
      Start:= Now;
      Res:= Gr.GenMinPairsDicoty;
      Time:= MilliSecondsBetween(Start, Now);
      ResultExpo('');
      ResultExpo(CFile);
      Res.Free;

      Gr.Free;
      Writeln('--------------------------------------------------------');
    until false;
  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.
