//////////////////////////////////////////////////////////////
//  

program Graph_20;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  Graph in '..\Common\Graph.pas',
  GrChars in '..\Common\GrChars.pas',
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas',
  SetList in '..\Common\SetList.pas',
  SetUtils in '..\Common\SetUtils.pas',
  Assembly in '..\Common\Assembly.pas';

(******************************************************
KRISTOFIDES Page 44
0 - (0), (1)
0 -  
0 -   ()
8 -  
A B C D E F G H
A -> B F H
B -> A C F
C -> B D E
D -> C E G
E -> C D F
F -> A B E G H
G -> D F
H -> A F
******************************************************)

var Gr: TGraphChars;
    //Undep: TSet;
    Colors: TSet;
    S : string;

begin
  try
  repeat
    Gr:= TGraphChars.Load('Page44.txt');
    //Gr:= TGraphChars.GenRandom(false, 1, 1, 20, 50);
    Gr.Expo;
    Writeln('- - - - - - - - - - - - - - - - - -');
(*
    Undep:= Gr.GenUndepend;
    Undep.Expo;
    Undep.ClrAndDestroy;
    Undep.Free;
    Writeln('- - - - - - - - - - - - - - - - - -');
*)
    Colors:= Gr.GenPaints(true);  // 
    Colors.Expo;
    Colors.ClrAndDestroy;
    Colors.Free;
    Writeln('- - - - - - - -');
    Colors:= Gr.GenPaints(false); // 
    Colors.Expo;
    Colors.ClrAndDestroy;
    Colors.Free;
    Writeln('- - - - - - - - - - - - - - - - - -');

    Write('Quit ? ');
    Readln(S);
    Gr.Free; //  
  until S<>'';
  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.
