program Graph_23c;

{
   P-
}

{$APPTYPE CONSOLE}

uses
  SysUtils,
  DateUtils,
  Assembly in '..\Common\Assembly.pas',
  Graph in '..\Common\Graph.pas',
  GrChars in '..\Common\GrChars.pas',
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas',
  SetList in '..\Common\SetList.pas',
  SetUtils in '..\Common\SetUtils.pas';

var Gr : TGraph;
    Median: TSet;
    Cost: integer;
    D : char;
    Direct : TCenter;
    P : integer;

procedure TestTime;
const C1 =20; C2 =5;
var i: integer;
    Start, Time : TDateTime;
begin

  case Direct of
    InCenter: Writeln('------------------- IN -------------------');
    OutCenter: Writeln('------------------- OUT -------------------');
    InOutCenter: Writeln('------------------- IN-OUT -------------------');
  end;
  Start:= Now;
  for i:= 1 to C1 do begin
    Median:= Gr.GenPMedian
                          (P,    // -  (P)
                          Direct,
                          Cost  //  ()
                          );
    if i < C1 then Median.Free;
  end;
  Time:= MilliSecondsBetween(Start, Now) / C1;
  Median.Expo;
  Median.Free;
  Writeln('Cost  = ', Cost:7, '  Time  = ', Time:7:2);

  //-------------------------------------------

  Start:= Now;
  for i:= 1 to C2 do begin
    Median:= Gr.GenPMedian_A
                          (P,    // -  (P)
                          Direct,
                          Cost  //  ()
                          );
    if i < C2 then Median.Free;
  end;
  Time:= MilliSecondsBetween(Start, Now) / C2;
  Median.Expo;
  Median.Free;
  Writeln('Cost_A= ', Cost:7, '  Time_A= ', Time:7:2);
  //-------------------------------------------

end;


begin
  try
  //  Gr:= TGraphChars.Load('Test_3.txt');
  //Gr:= TGraphChars.Load('Test_4d.txt');
  //Gr:= TGraphChars.Load('Test_5.txt');
//  Gr:= TGraphChars.Load('Test_5d.txt');
  //Gr:= TGraphChars.Load('Test_7d.txt');
  Gr:= TGraphChars.Load('Test_9.txt');
//  Gr:= TGraphChars.GenRandom(false, 10, 10, 45, 50);
//  Gr:= TGraphChars.GenRandom(false, 10, 10, 50, 50);
//(Gr as TGraphChars).Save('Test_9.txt');
  Gr.Expo;
  Writeln('- - - - - - - - - - - - - - - - - -');
  Write('Direction (I/O/A) = '); Readln(D);
  case Upcase(D) of
    'I': Direct:= InCenter;
    'O': Direct:= OutCenter;
    else Direct:= InOutCenter;
  end;
  repeat
    Write('P= '); Readln(P);
    if P=0 then Break;
    TestTime;
    Writeln;
  until false;
  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.
